/* Josh Pieper, (c) 2000 */

/* This file is distributed under the GPL, see file COPYING for details */

#ifndef QUERY_H
#define QUERY_H

#include "gnut_lib.h"
#include "Gnut_List.h"

typedef struct _query_response query_response;

struct _query_response {
  uchar ip[4];
  uchar port[2];
  int ref;
  int speed;
  int size;
  char *name;
  uchar guid[16];
  int index;
  int dest_cache;
  int crc;
};


int query_init();
int query_unique();

int query_add(uchar ip[4], uchar port[2], int ref, int speed,
  int size, char *name, uchar guid[16]);
int query_add_cache(uchar ip[4], uchar port[2], int ref, int speed,
  int size, char *name, uchar guid[16]);
  
int query_clear();

query_response * query_index(int index);

query_response * query_find(uchar guid[16], uint32 ref);

uint32 query_num();

int query_lock();
Gnut_List * query_retrieve();
int query_unlock();

#define MAX_OUTSTANDING_PUSHES 50

int query_push_add(query_response *qr);
query_response * query_push_find(uchar guid[16], uint32 ref);
void query_push_remove(query_response *qr);


#endif
